// C Source File
// Created 11/01/04; 14:57:36

#define RIEN 255
#define BRIQUE 1
#define PIC_EN_HAUT 2
#define PIC_EN_BAS 3
#define PIC_A_DROITE 4
#define PIC_A_GAUCHE 5
#define ARRIVEE 6
#define MINE 7 //pics (multi-pic)
#define JUMPER_HAUT 8
#define SOUFFLERIE_HAUT 9
#define GRAVITE_PLUS 11
#define GRAVITE_NORMALE 12
#define CHECKPOINT 13
#define SOUFFLERIE_BAS 17
#define SOUFFLERIE_GAUCHE 18
#define SOUFFLERIE_DROITE 19
#define GLACE 20
#define JUMPER_BAS 21
#define JUMPER_GAUCHE 22
#define JUMPER_DROITE 23
#define DEPART 24
#define GRAVITE_INVERSE 25
#define PICS_CLIGNOTANTES_DEBUT 41//PICS_CLIGNOTANTES 41  50
#define PICS_CLIGNOTANTES_FIN 50
#define PICS_MVT_HAUT 51
#define PICS_MVT_GAUCHE 52
#define PICS_MVT_BAS 53
#define PICS_MVT_DROITE 54
#define OBJET_VIDE 55
#define TOUCHES 56
#define TOUCHES_GAUCHE_DROITE 57
#define TOUCHES_HAUT_BAS 58
#define INVERSE_TOUT 59
#define INVERSE_GAUCHE_DROITE 60
#define INVERSE_HAUT_BAS 61

#define J (j<<3) // (j*8)
#define K (k<<3) // (k*8)
#define light GrayGetPlane (LIGHT_PLANE)
#define dark GrayGetPlane (DARK_PLANE)
#define NB_LEVEL 110
#define HIGH_SIZE (2+16)*NB_LEVEL+8
#define LEVEL_SIZE 260
#define HAUT 1
#define GAUCHE 2
#define BAS 3
#define DROITE 4

#define MAX_HASHTABLE 261
#define MAX_OBJET 240

typedef struct {
	int x;
	int y;
	int type;
}OBJET;

#include <tigcclib.h>         // Include All Header files

INT_HANDLER OldInt1 = NULL;
INT_HANDLER OldInt5 = NULL;
volatile int Counter = 0;
volatile int compteur = 0;
volatile int objet_on = 0;
unsigned char m[13][20]; //tableau principal qui va contenir le level
unsigned char packlevel[18];//nom du pack de levels

DEFINE_INT_HANDLER(MyInt5)
{
  if (Counter++ % 2) objet_on = (objet_on ^ (1 << ((Counter % 20) >> 1))) ;
}
DEFINE_INT_HANDLER (MyInt1)
{
	compteur++; //ce compteur servira  ralentir le programme
}

#include "extgraph.h"
#include "graphique.h"
#include "hachage.h"
#include "fonctions graphiques.h"
#include "soufflerie.h"
#include "fonctions.h"
#include "highscores.h"
#include "menu.h"




//int pres=1;
	

void _main(void)
{
	unsigned char nb_level=0, buffer[50], on[LEVEL_SIZE]={};
	int tour=0, a, b, lvl=1, jump=1, time ;
	int x,y,xn,yn;
	int vect[2],gravite=1, coef_friction=1;
	int gauche_droite=1, haut_bas=1;
	int inverse_gauche_droite,inverse_haut_bas;
	int j,k,colli;
	int checkx,checky, checkg, check_gd, check_hb, check_igd, check_ihb;
	int zone_balle, zone_objet=zone_objet; // designe la zone de la balle et des objets lors du test de collision
	int zone_dep[9] = {-19,-20,-21,-1,0,1,19,20,21};
	HASHTABLE *h = NULL;
	CELLULE *c;
	OBJET *o;
	int objet_teste[MAX_OBJET];
	
	ESI argptr;
	InitArgPtr (argptr);
	packlevel[0]=0;
	if (GetArgType (argptr) == STR_TAG) //test si on a pass un level en argument
		strcpy(packlevel,GetStrnArg(argptr));
	if (packlevel[0]==0) strcpy(packlevel, "gravlvl"); //si pas de level pass en argument, mettre "gravlvl"

	HANDLE handle;
	char *fptr;
	SYM_ENTRY *openlevel_sym;
	if ((openlevel_sym=SymFindPtr(SYMSTR(packlevel),0))) //si packlevel existe, ouverture du fichier
	{
		handle=openlevel_sym->handle;
  	fptr=HeapDeref(handle);
  	nb_level = (unsigned char) *(fptr+3); //lecture du deuxieme caractere qui correspond au nombre de levels
	}
	else {ST_helpMsg ("Level introuvable."); ngetchx(); return;} //si le level n'existe pas
  

	OldInt1 = GetIntVec (AUTO_INT_1); 
	OldInt5 = GetIntVec (AUTO_INT_5);
  SetIntVec (AUTO_INT_5, MyInt5); //redirection des interruptions
	SetIntVec (AUTO_INT_1, MyInt1); //redirection des interruptions
	
	if (!GrayOn ()) return; //activation des niveaux de gris
	
	presentation();
	
menujeu:

	lvl=menu(lvl, nb_level); //menu et retour du level choisi
	checkx=0; checky=0; checkg=1;  //remise  0 des checkpoints (et de la gravit)
	check_gd=1;check_hb=1;
	check_igd=1;check_ihb=1;
	if (h) liberer_hashtable(h); // libre la place alloue pour la table de hachage
	if (lvl==0) //si on a appuy sur ESC
	{
		GrayOff(); //fin des niveaux de gris
		SetIntVec (AUTO_INT_1, OldInt1); //remise en place des vecteurs d'interruptions
		SetIntVec (AUTO_INT_5, OldInt5); //remise en place des vecteurs d'interruptions
		return; //fin du programme
	}
  h = hachage_init();
	memset(objet_teste,0,MAX_OBJET * sizeof(int));

deb:

  memset(light,0,LCD_SIZE); //efface l'cran
  memset(dark,0,LCD_SIZE); //efface l'cran
	memset(vect,0,2*sizeof(int)); //vitesse

	if (checkx==0 && checky==0)  //si on n'a pas atteint de checkpoints
	{	
		x=0; y=32*8; //initialisation de la position de depart de la balle	
		hachage_reinit(h);
		init_mvt(h, fptr, lvl, &x, &y);	
		affiche_level(); //affichage du level
		gauche_droite=1; haut_bas=1; //initialisation des touches autorises
		inverse_gauche_droite = 1 ; inverse_haut_bas = 1; //initialisation des touches inverses
		Counter = 0; objet_on = 0; gravite=1; //remise a zero du temps, des objets clignotants et de la gravite
		xn=x; yn=y; //initialisation de xnouveau et ynouveau  x et y
	}
	else //sinon placement de la balle au bon endroit
	{
		affiche_level(); //affichage du level
		x = xn = checkx;
		y = yn = checky;
		gravite = checkg;
		gauche_droite = check_gd;
		haut_bas = check_hb;
		inverse_gauche_droite =  check_igd; 
		inverse_haut_bas = check_ihb;
	}

/*****debut du jeux*****/
	while (Counter < 10*60*20) //tant que moins de 10 minutes
	{	
  	while (compteur < (HW_VERSION==1 ? 6 : 4)); // ralentit le programme
		compteur=0;

   	
   	if (_keytest(RR_LEFT) && gauche_droite) {vect[0]-=inverse_gauche_droite;}
   	if (_keytest(RR_RIGHT) && gauche_droite) {vect[0]+=inverse_gauche_droite;}
    if (_keytest(RR_UP) && haut_bas && (tour % 4 == 0)) {vect[1]-=2 * inverse_haut_bas;}
    if (_keytest(RR_DOWN) && haut_bas && (tour % 2 == 0)) {vect[1]+=inverse_haut_bas;}
   	if (_keytest(RR_APPS)) off();
   	if (_keytest(RR_F2)) {while (_keytest(RR_CLEAR)); goto deb;}
   	if (_keytest(RR_ESC)){while (_keytest(RR_ESC)); goto menujeu;}
		if (_keytest(RR_PLUS) && (tour % 8 == 0)){OSContrastUp ();}
		if (_keytest(RR_MINUS) && (tour % 8 == 0)){OSContrastDn ();}
  		
		if (tour % (4 * ((gravite+5)/4)) == 0) vect[1]+=gravite; //gravite
		//vect[0]= (vect[0]*(4-coef_friction*3))/(3-coef_friction*2); //pour la glace
		if (tour % 4 == 0 && vect[0]!=0) {if (vect[0]>0) vect[0] -= coef_friction; else vect[0] += coef_friction;} //frottements
		
		if (vect[0]>32) vect[0]=32;		////////////////////////////////////////////////
		if (vect[0]<-32) vect[0]=-32;	//Limitation de la vitesse										//
		if (vect[1]>32) vect[1]=32;		//pour ne pas dpasser un pixel de dplacement//
		if (vect[1]<-32) vect[1]=-32;	////////////////////////////////////////////////
		
		
		//<rebonds sur les bords de l'cran>
		if((x+vect[0]) < 0){vect[0]=-vect[0]-8;xn=0;}
	 	else if((x+vect[0]) > 152*32){vect[0]=-vect[0]+8; xn=152<<5;}
	 	else xn=x+vect[0];
	 	if((y+vect[1]) < 0){vect[1]=-vect[1] - (vect[1]<-3 ? 2 : 0) * 4;yn=0;}
	 	else yn=y+vect[1];
		//</rebonds sur les bords de l'cran>
	
//animation :
		if (tour % 4 == 0 )
		{
			for (j=0;j<13;j++)
			{
				for (k=0;k<20;k++)
				{
					if (m[j][k] >= PICS_CLIGNOTANTES_DEBUT && m[j][k] <= PICS_CLIGNOTANTES_FIN ) //pics clignotantes
					{
						if ((objet_on >> (m[j][k] % 10)) & 1){on[k*20+j]=1; GrayTile8x8_RPLC_R(k,J,pics1,pics2,light,dark);}
						else if (on[k*20+j]==1){on[k*20+j]=0;GraySprite8_AND (K, J, 8, mask, mask, light, dark);}
					}
					switch (m[j][k]) 
					{
						case JUMPER_HAUT 		   : GrayTile8x8_RPLC_R(k, J, jump11[jump], jump21[jump], light, dark); break;
						case SOUFFLERIE_HAUT   : GrayTile8x8_RPLC_R(k, J, soufflerie11[tour>>2], soufflerie21[tour>>2], light, dark); break;
						case GRAVITE_PLUS		   : GrayTile8x8_RPLC_R(k, J, plus, plus, light, dark); break;
						case GRAVITE_NORMALE   : GrayTile8x8_RPLC_R(k, J, zero, zero, light, dark); break;
						case CHECKPOINT			   : GrayTile8x8_RPLC_R(k, J, checkpoint1, checkpoint2, light, dark); break;
						case SOUFFLERIE_BAS  	 : GrayTile8x8_RPLC_R(k, J, soufflerie13[tour>>2], soufflerie23[tour>>2], light, dark); break;
						case SOUFFLERIE_GAUCHE : GrayTile8x8_RPLC_R(k, J, soufflerie12[tour>>2], soufflerie22[tour>>2], light, dark); break;
						case SOUFFLERIE_DROITE : GrayTile8x8_RPLC_R(k, J, soufflerie14[tour>>2], soufflerie24[tour>>2], light, dark); break;
						case JUMPER_BAS			   : GrayTile8x8_RPLC_R(k, J, jump12[jump], jump22[jump], light, dark); break;
						case JUMPER_GAUCHE	   : GrayTile8x8_RPLC_R(k, J, jump13[jump], jump23[jump], light, dark); break;
						case JUMPER_DROITE     : GrayTile8x8_RPLC_R(k, J, jump14[jump], jump24[jump], light, dark); break;
					  case GRAVITE_INVERSE   : GrayTile8x8_RPLC_R(k, J, moins, moins, light, dark); break;
					  case ARRIVEE					 : GrayTile8x8_RPLC_R(k, J, arrive, arrive, light, dark); break;
					  case TOUCHES					 : 
					  case TOUCHES_GAUCHE_DROITE : 
					  case TOUCHES_HAUT_BAS	 :
					  	GrayTile8x8_RPLC_R(k, J, pave1[m[j][k]-TOUCHES], pave2[m[j][k]-TOUCHES], light, dark); break;
						case INVERSE_TOUT      :
					  case INVERSE_GAUCHE_DROITE :
					  case INVERSE_HAUT_BAS  :	  
					  	GrayTile8x8_RPLC_R(k, J, inverse1[m[j][k]-INVERSE_TOUT], inverse2[m[j][k]-INVERSE_TOUT], light, dark); break;	
					}
				}
			}
			if (tour==0) jump=1-jump; 
		}
		
		GraySprite8_OR (x>>5, y>>5, 8, balle1, balle2, light, dark); //reaffichage de la balle pour eviter les clignotements
//fin animation.
		
		coef_friction=1; //coefficient de base de frottement
		
		
		if (tour%4==0)
		{		
			// Collision des objets avec lmets de la carte
			for (j=0 ; j<h -> nb_total ; j++) {
				if (!objet_teste[j]) {
					c = h -> reference[j];	
					o = &(c -> objet);
					switch (o -> type) {
						case PICS_MVT_HAUT : if (o -> y<1 || !LaissePasser((o -> y-1)/8, o -> x/8)) propager_collision(h,c,20,objet_teste); break;
						case PICS_MVT_GAUCHE : if (o -> x<1 || !LaissePasser(o -> y/8, (o -> x-1)/8)) propager_collision(h,c,1,objet_teste); break;
						case PICS_MVT_BAS : if (!LaissePasser(o -> y/8+1, o -> x/8)) propager_collision(h,c,-20,objet_teste); break;
						case PICS_MVT_DROITE : 	if (o -> x>19*8-2 || !LaissePasser(o -> y/8, o -> x/8+1)) propager_collision(h,c,-1,objet_teste); break;
					}		
				}
			}

		
			// Collision entre objets
			for (j=0; j<h->nb_total ; j++)
			{	
				if (!objet_teste[j]) {
					o = &((h -> reference[j]) -> objet);
					switch (o -> type) {
						case PICS_MVT_HAUT : zone_objet = o ->x/8 + (o->y-8)/8 * 20; break;
						case PICS_MVT_BAS : zone_objet = o -> x/8 + (o -> y+8)/8 * 20; break;
						case PICS_MVT_GAUCHE : zone_objet = (o -> x-8)/8 + o -> y/8 * 20; break;
						case PICS_MVT_DROITE : zone_objet = (o -> x+8)/8 + o -> y/8 * 20; break;
					}

					// test dans la zone suivante
					c = h -> table[zone_objet];
					while (c != NULL) {
						if (o -> type==PICS_MVT_HAUT && (c->objet).type==PICS_MVT_BAS && (o -> y - 8) <= (c -> objet).y ){ 
							propager_collision(h,c,-20,objet_teste);
							propager_collision(h,h -> reference[j],20,objet_teste);
						}
						else if (o -> type==PICS_MVT_GAUCHE && (c->objet).type==PICS_MVT_DROITE && (o -> x - 8) <= (c -> objet).x ){
							propager_collision(h,c,-1,objet_teste);
							propager_collision(h,h -> reference[j],1,objet_teste);
						}
						else if (o -> type==PICS_MVT_BAS && (c->objet).type==PICS_MVT_HAUT && (o -> y + 8) >= (c -> objet).y ){
							propager_collision(h,c,20,objet_teste);
							propager_collision(h,h -> reference[j],-20,objet_teste);
						}
						else if (o -> type==PICS_MVT_DROITE && (c->objet).type==PICS_MVT_GAUCHE && (o -> x + 8) >= (c -> objet).x ){
							propager_collision(h,c,1,objet_teste);
							propager_collision(h,h -> reference[j],-1,objet_teste);
						}
						c = next(c);
					} 	
				}	
			}

			memset(objet_teste,0,MAX_OBJET * sizeof(int)); // reinitialise la liste des objets tests pour collision

			// Deplacement des objets
			for (j=0 ; j<h -> nb_total ; j++) {
				c = h -> reference[j];	
				o = &(c -> objet);
				
				GraySprite8_AND (o -> x, o -> y, 8, mask2, mask2, light, dark); //effacement de l'ancien objet
				if (o -> type==PICS_MVT_HAUT) o -> y--;
				if (o -> type==PICS_MVT_GAUCHE) o -> x--;
				if (o -> type==PICS_MVT_BAS) o -> y++;
				if (o -> type==PICS_MVT_DROITE) o -> x++;
				ht_deplacer_objet(h,c,c->zone,o -> x, o-> y); // actualise la place des objets
				GraySprite8_OR (o -> x, o->y, 8, pics1, pics2, light, dark); //affichage  la nouvelle coordonne
			} // fin for j
						
			// Collision de la balle avec les objets 
			//  pr tour %2 p
			zone_balle = (xn >> 5)/8 + (yn >> 5)/8 * 20;
			for (k = 0; k<9 ; k++) {
				zone_objet = zone_balle + zone_dep[k];
				if (zone_objet > -1 && zone_objet < MAX_HASHTABLE) {
					c = h -> table[zone_objet];
					while (c != NULL) {
						if (TestCollide8_R(xn>>5,yn>>5,(c -> objet).x,(c -> objet).y,8,balle2, pics2)) {
							if (gameover(x,y,"Jeu termin.")==1)goto deb; else goto menujeu;
						}
						c = next(c);
					} 
				}
			}	
		}
		

		
		
		
		a=yn>>8 ; // /(256) //////////////////////////////////////////
		b=xn>>8 ; // /(256) //calcul pour ne tester que 4 collisions//
		if (b>19)b=19;			//////////////////////////////////////////
		
		for (j= a;j<a+2;j++)
		{
			for (k=b;k<b+2;k++)
			{
				if ((m[j][k]>= PICS_CLIGNOTANTES_DEBUT && m[j][k]<= PICS_CLIGNOTANTES_FIN && (objet_on >> (m[j][k] % 10)) & 1) || m[j][k]==MINE) //si la pic clignotante est allume
				{
					if(TestCollide8_R(xn>>5,yn>>5,k*8,j*8,8,balle2, pics2)){if (gameover(x,y,"Jeu termin.")==1)goto deb; else goto menujeu;}
					//if(collision(xn,yn,j*8,k*8,0b1111,pics2)){if (gameover(x,y,"Jeu termin.")==1)goto deb; else goto menujeu;}
				}
				if (m[j][k]==BRIQUE || m[j][k]==SOUFFLERIE_HAUT || m[j][k]==JUMPER_HAUT || (m[j][k]>=SOUFFLERIE_BAS && m[j][k]<=JUMPER_DROITE)) //test brique+glace+jumpers+souffleries
				{
					colli=collision(xn,yn,j*8,k*8,0b0000,carre1);
					if (colli==HAUT) 
					{
						vect[1]=(m[j][k]==JUMPER_HAUT ? -32 : -vect[1] + (vect[1]>3 ? 8 : 0)); 
						if (TestCollide8_R(xn>>5,(yn-32)>>5,k*8,j*8,8,balle2, carre1)) yn-=32;
						yn-=32;
						if (m[j][k]==GLACE)coef_friction = 0; 
					}
					if (colli==GAUCHE) {vect[0]=(m[j][k]==JUMPER_GAUCHE ? -32 : -vect[0]+8); xn=xn-32;}
					if (colli==DROITE) {vect[0]=(m[j][k]==JUMPER_DROITE ? 32 : -vect[0]-8); xn=xn+32;}
					if (colli==BAS) 
					{
						vect[1]=(m[j][k]==JUMPER_BAS ? 32 : -vect[1] - (vect[1]<-3 ? 8 : 0));
						if (TestCollide8_R(xn>>5,(yn+32)>>5,k*8,j*8,8,balle2,carre1)) yn+=32;
						yn+=32;
					}
				}
				if (m[j][k]>=PIC_EN_HAUT && m[j][k]<=PIC_A_GAUCHE) //test des 4 pics
				{
					int laPic=(m[j][k]==PIC_EN_HAUT)+(m[j][k]==PIC_A_GAUCHE)*2+(m[j][k]==PIC_EN_BAS)*3+(m[j][k]==PIC_A_DROITE)*4 - 1;
					colli=collision(xn,yn,j*8,k*8,1<<laPic,pic2[laPic]);
					if (colli==HAUT) 
					{
						vect[1]=-vect[1] + (vect[1]>3 ? 8 : 0);
						if (TestCollide8_R(xn>>5,(yn-32)>>5,k*8,j*8,8,balle2, pic2[laPic])) yn-=32;
						yn=yn-32;
					}
					if (colli==GAUCHE) { vect[0]=-vect[0]+8; xn=xn-32;}
					if (colli==DROITE) { vect[0]=-vect[0]-8; xn=xn+32;}
					if (colli==BAS) 
					{
						vect[1]=-vect[1] - (vect[1]<-3 ? 8 : 0);
						if (TestCollide8_R(xn>>5,(yn+32)>>5,k*8,j*8,8,balle2,pic2[laPic])) yn+=32;
						yn=yn+32;
					}
					if (colli==laPic+1) {if (gameover(x,y,"Jeu termin.")==1)goto deb; else goto menujeu;}
				}
				if (m[j][k]==ARRIVEE && TestCollide8_R(xn>>5,yn>>5,k*8,j*8,8,balle2,arrive)) //si on a touch le A (arrive)
				{
					time = Counter;
					sprintf (buffer, "Temps : %d \" %d ", time/(20),(time%(20))*5);
					drawbox(10,36,151,62);
					GraySetAMSPlane (DARK_PLANE);
					DrawStr (43, 40, "Bien jou !!!", A_XOR);
					DrawStr (23, 50, buffer, A_XOR);
					GraySetAMSPlane (LIGHT_PLANE);
					DrawStr (44, 41, "Bien jou !!!", A_XOR);
					DrawStr (24, 51, buffer, A_XOR);
					while (!_keytest(RR_ENTER) && !_keytest(RR_2ND));
					if (strcmp (packlevel, "gravlvl")==0) high(time,lvl); //si on est dans les levels officiels : alors highscores
					while (_keytest(RR_ENTER) || _keytest(RR_2ND));
					goto menujeu; //retour au menu
				}
				if (m[j][k]==GRAVITE_PLUS && TestCollide8_R(xn>>5,yn>>5,k*8,j*8,8,balle2,plus)) gravite=3;
				if (m[j][k]==GRAVITE_NORMALE && TestCollide8_R(xn>>5,yn>>5,k*8,j*8,8,balle2,zero)) gravite=1;
				if (m[j][k]==GRAVITE_INVERSE && TestCollide8_R(xn>>5,yn>>5,k*8,j*8,8,balle2,moins)) gravite=-1;
				
				if (m[j][k]==TOUCHES && TestCollide8_R(xn>>5,yn>>5,k*8,j*8,8,balle2,pave1[0])) {gauche_droite=1; haut_bas=1;inverse_gauche_droite=1; inverse_haut_bas=1;}
				if (m[j][k]==TOUCHES_GAUCHE_DROITE && TestCollide8_R(xn>>5,yn>>5,k*8,j*8,8,balle2,pave1[1])) {gauche_droite=1; haut_bas=0;inverse_gauche_droite=1; inverse_haut_bas=1;}
				if (m[j][k]==TOUCHES_HAUT_BAS && TestCollide8_R(xn>>5,yn>>5,k*8,j*8,8,balle2,pave1[2])) {gauche_droite=0; haut_bas=1;inverse_gauche_droite=1; inverse_haut_bas=1;}
				if (m[j][k]==INVERSE_TOUT && TestCollide8_R(xn>>5,yn>>5,k*8,j*8,8,balle2,inverse1[0])) {inverse_gauche_droite=-1; inverse_haut_bas=-1;gauche_droite=1; haut_bas=1;}
				if (m[j][k]==INVERSE_GAUCHE_DROITE && TestCollide8_R(xn>>5,yn>>5,k*8,j*8,8,balle2,inverse1[1])) {inverse_gauche_droite=-1; inverse_haut_bas=1;gauche_droite=1; haut_bas=1;}
				if (m[j][k]==INVERSE_HAUT_BAS && TestCollide8_R(xn>>5,yn>>5,k*8,j*8,8,balle2,inverse1[2])) {inverse_gauche_droite=1; inverse_haut_bas=-1;gauche_droite=1; haut_bas=1;}
				
				
				if (m[j][k]==CHECKPOINT && TestCollide8_R(xn>>5,yn>>5,k*8,j*8,8,balle2,checkpoint1)) 
				{
					checkx=K <<5 ; checky=J <<5 ; checkg=gravite ;
					check_gd = gauche_droite;
					check_hb = haut_bas;
					check_igd = inverse_gauche_droite;
					check_ihb = inverse_haut_bas;
				}
			
			}
		}
		
		// Test pour savoir si la balle est prise par le vent
		if (tour % 2 == 0)
			{
				if (soufflerie_gauche(yn >> 8, xn >> 8, yn >> 5, h)) vect[0]++ ;
				else if (soufflerie_gauche((yn >> 8) + 1, xn >> 8, yn >> 5, h)) vect[0]++ ;
				if (soufflerie_droite(yn >> 8, xn >> 8, yn >> 5, h)) vect[0]-- ;
				else if (soufflerie_droite((yn >> 8) + 1, xn >> 8, yn >> 5, h)) vect[0]-- ;
				if (soufflerie_haut(yn >> 8, xn >> 8, xn >> 5, h)) vect[1]++ ;
				else if (soufflerie_haut(yn >> 8, (xn >> 8) + 1, xn >> 5, h)) vect[1]++ ;
				if (soufflerie_bas(yn >> 8, xn >> 8, xn >> 5, h)) vect[1]-- ;
				else if (soufflerie_bas(yn >> 8, (xn >> 8) + 1, xn >> 5, h)) vect[1]-- ;
			}
		
		GraySprite8_AND (x>>5, y>>5, 8, mask, mask, light, dark); //effacement de l'ancienne balle
		GraySprite8_OR (xn>>5, yn>>5, 8, balle1, balle2, light, dark); //affichage de la balle
		x=xn; y=yn; // actualise les coordonnes de la balle
		if (++tour==16) tour=0; //compteur interne
	}
	gameover(xn,yn,"Hors dlai.");
	goto menujeu;
}