// Header File
// Created 24/12/04; 14:34:32

struct cellule {
	OBJET objet; 
	int numero; // numro de l'objet attribu  l'initialisation du level <=> indice dans la table de references
	int zone; // zone de la carte  laquelle appartient l'objet <=> indice ds la table de hachage 
	struct cellule *suivante;
	struct cellule *precedente;
};
typedef struct cellule CELLULE;

struct table_de_hachage {
	CELLULE *table[MAX_HASHTABLE]; // objets rangs par zone
	CELLULE *reference[MAX_OBJET]; // garde une rfrence sur tous les objets pour un accs rapide
	int nb_total; // nombre total d'objet	
};
typedef struct table_de_hachage HASHTABLE;


// Initialise la table de hachage
HASHTABLE* hachage_init(void) {
	int i;
	HASHTABLE* result;
	result = (HASHTABLE*)malloc(sizeof(HASHTABLE));
	for (i=0; i<MAX_HASHTABLE; i++) result -> table[i] = NULL;
	result -> nb_total = 0;
	return result;
}

// Reinitialise la table de hachage -> ne ralloue pas la table
void hachage_reinit(HASHTABLE* h) {
	int i;
	for (i=0; i< h->nb_total; i++) {
		free(h -> reference[i]);
	}
	for (i=0; i<MAX_HASHTABLE; i++) h -> table[i] = NULL;
	h -> nb_total = 0;
}


//Ajouter un objet
void ht_ajouter_objet(HASHTABLE *h, OBJET* o) {
	CELLULE* c = (CELLULE*)malloc(sizeof(CELLULE));
	int h_code = o -> x/8 + o->y/8 * 20;
	// cre la cellule
	c -> objet = *o; 
	c -> zone = h_code;
	c -> numero = h -> nb_total;
	c -> suivante = h -> table[h_code];
	if (c -> suivante != NULL) (c -> suivante) -> precedente = c;
	c -> precedente = NULL;
	// affecte la cellule  la table
	h -> table[h_code] = c;
	h -> reference[h -> nb_total] = c; 	
	(h -> nb_total)++;
}

//Deplacer objet
void ht_deplacer_objet(HASHTABLE *h, CELLULE* c, int h_code_deb, int x, int y) {
	int h_code_fin = x/8 + y/8 * 20;
	if (h_code_fin != h_code_deb) {
		if (c -> precedente == NULL) {
			h -> table[h_code_deb] = c -> suivante;
			if (c -> suivante != NULL) (c -> suivante) -> precedente = NULL;
		} else {
			(c -> precedente) -> suivante = c -> suivante;
			if (c -> suivante != NULL) (c -> suivante) -> precedente = c -> precedente;
		}
		c -> suivante = h -> table[h_code_fin];
		if (c -> suivante != NULL) (c -> suivante) -> precedente = c;
		c -> precedente = NULL;
		h -> table[h_code_fin] = c;
		c -> zone = h_code_fin;
	}
}

CELLULE* next(CELLULE* c) {
	return c -> suivante;
}


/**********************
LIBERATON DE LA MEMOIRE
**********************/

void liberer_hashtable(HASHTABLE *h) {
	int i;
	for (i=0; i< h->nb_total; i++) {
		free(h -> reference[i]);
	}
	free(h);
}
